#include <windows.h>
#include <stdio.h>
#include <ctype.h>


#include "TMSGs.h"

#define _INFO 0
#define _ERROR 1
#define _WARNING 2
#define _ExtendedInfo 100



//========================================================================================
typedef void (__cdecl *PrepareEMMKeyFunction)(char* SysName, long ProviderID, char* KeyIdx, unsigned char* Key, int keyLen);
PrepareEMMKeyFunction _kEMMFn = NULL;
extern "C" __declspec(dllexport) void SetPrepareEMMKeyCallBackFn(PrepareEMMKeyFunction fn)
{
    _kEMMFn = fn;
}
void PrepareEMMKey(char* SysName, long ProviderID, char* KeyIdx, unsigned char* Key, int keyLen)
{
    if (_kEMMFn==NULL) return;
    if (!IsKeyNull(Key,keyLen))
        (*_kEMMFn)(SysName, ProviderID, KeyIdx, Key, keyLen);
}


//========================================================================================

typedef void (__cdecl *SendMsgFunction)(char* data,unsigned char type);
SendMsgFunction _fn = NULL;
extern "C" __declspec(dllexport) void SetMessagesCallBackFn(SendMsgFunction fn)
{
    _fn = fn;
}

void SendMSG(unsigned char type, char * fmt, ...)
{
    if (_fn==NULL) return;
    char Message[3000];
    va_list argp;
    va_start(argp, fmt);
    vsprintf(Message,fmt, argp);
    va_end(argp);

    (*_fn)(Message,type);
}

///////////////////////////////////////////////////////////////////////////////
const char *HexStr(char *str, const unsigned char *mem, int len)
{
    for (int i=0 ; i<len ; i++) sprintf(&str[i*2],"%02X",mem[i]);
    return str;
}

///////////////////////////////////////////////////////////////////////////////
// hex to asc: 0x22 -> "22"
int Hex2Asc(char *Dest,char *Src,int SrcLen)
{
    int i;
    for ( i = 0; i < SrcLen; i ++ )
    {
        sprintf(Dest + i * 2,"%02X",(unsigned char)Src[i]);
    }
    Dest[i * 2] = 0;
    return TRUE;
}

void IntToHex(char *Dest,int data)
{
    sprintf(Dest ,"%02X",data);
}

///////////////////////////////////////////////////////////////////////////////
// asc to hex: "22" -> 0x22
int Asc2Hex(char *Dest,char *Src,int SrcLen)
{
    int i;
    for ( i = 0; i < SrcLen / 2; i ++ )
    {
        sscanf(Src + i * 2,"%02X",(unsigned char *)&Dest[i]);
    }
    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////

void SendHexDump(char* label ,unsigned char type,const unsigned char *buffer, int n)
{
    if (_fn==NULL) return;
    char Message[3000];
    HexStr(Message,buffer,n);
    char *str3 = (char *)malloc((strlen(label) + strlen(Message) + 1)*sizeof(char));
    if (str3)
    {
        strcpy(str3, label);
        strcat(str3, Message);
        (*_fn)(str3,type);
        free(str3);
    }
}

void RB(unsigned char *in, int n)
{
	unsigned char *e=in+n-1;
	do {
		unsigned char temp=*in;
		*in++=*e;
		*e-- =temp;
	} while(in<e);
}
//========================================================================================


//========================================================================================
typedef void (__cdecl *RequestKeyFunction)(char* SysName, long ProviderID, char* KeyIdx, unsigned char* Key);
RequestKeyFunction _kFn = NULL;
extern "C" __declspec(dllexport) void SetRequestKeyCallBackFn(RequestKeyFunction fn)
{
    _kFn = fn;
}
void RequestKey(char* SysName, long ProviderID, char* KeyIdx, unsigned char* Key)
{
    if (_kFn==NULL) return;
    (*_kFn)(SysName, ProviderID, KeyIdx, Key);
}

bool IsKeyNull(unsigned char* key, int len)
{
    bool res = true;
    for (int i=0; i< len; i++)
        if (key[i]!=0)
        {
            res = false;
            break;
        }

    return res;
}
//========================================================================================

